import * as React from "react";
import type { History, Location, RouteMatch, Router, To } from "@remix-run/router";
import { Action as NavigationType } from "@remix-run/router";
export declare const DataRouterContext: React.Context<Router | null>;
export declare const DataRouterStateContext: React.Context<import("@remix-run/router").RouterState | null>;
export interface NavigateOptions {
    replace?: boolean;
    state?: any;
    resetScroll?: boolean;
}
/**
 * A Navigator is a "location changer"; it's how you get to different locations.
 *
 * Every history instance conforms to the Navigator interface, but the
 * distinction is useful primarily when it comes to the low-level <Router> API
 * where both the location and a navigator must be provided separately in order
 * to avoid "tearing" that may occur in a suspense-enabled app if the action
 * and/or location were to be read directly from the history instance.
 */
export interface Navigator {
    createHref: History["createHref"];
    go: History["go"];
    push(to: To, state?: any, opts?: NavigateOptions): void;
    replace(to: To, state?: any, opts?: NavigateOptions): void;
}
interface NavigationContextObject {
    basename: string;
    navigator: Navigator;
    static: boolean;
}
export declare const NavigationContext: React.Context<NavigationContextObject>;
interface LocationContextObject {
    location: Location;
    navigationType: NavigationType;
}
export declare const LocationContext: React.Context<LocationContextObject>;
interface RouteContextObject {
    outlet: React.ReactElement | null;
    matches: RouteMatch[];
}
export declare const RouteContext: React.Context<RouteContextObject>;
interface RouteContextObject {
    outlet: React.ReactElement | null;
    matches: RouteMatch[];
}
export declare const RouteErrorContext: React.Context<any>;
export {};
